#! /usr/bin/env python

from __future__ import division

import sys
import os
import time
import threading
import serial

robot = serial.Serial('tty.arduino', timeout=0)
robotSensors = serial.Serial('/dev/tty.usbserial-A4000Oz6', timeout=0)
statements = []
statementsLock = threading.Lock()
statementsAvailible = threading.Event()


def getDistances():
    while '\n' in robotSensors.readline():
        pass
    s = ''
    while s == '' or len(s.split()) != 2:
        s = robotSensors.readline()
    return map(int, s.split())

def consume():
    while True:
        statementsAvailible.wait()
        statementsLock.acquire()
        statement = statements[-1]
        del statements[:]
        statementsAvailible.clear()
        statementsLock.release()
        robot.write('0')
        while '\n' in robot.readline():
            pass
            #print 'Eating input'
        if 'left' in statement:
            robot.write('l')
        elif 'right' in statement:
            robot.write('r')
        else:
            robot.write('c')
        timeout = 50
        while robot.readline().strip() not in ('Centered.', 'Left.', 'Right.')\
                and timeout > 0:
            #print 'Waiting for turn...'
            time.sleep(.1)
            timeout -= 1
        robot.write('s')
        if True in [d < 20  for d in getDistances()]:
            robot.write('3')
        else:
            print 'Something\'s there!'
        time.sleep(1)
        robot.write('0')

def produce():
    while True:
        line = sys.stdin.readline()
        if line == '':
            return
#        print line.strip()
        statementsLock.acquire()
        statements.append(line)
        statementsAvailible.set()
        statementsLock.release()

if __name__ == '__main__':
    consumer = threading.Thread(target=consume, name='consumer')
    consumer.setDaemon(True);
    consumer.start()
    produce()

